<ui:composition xmlns:h="http://java.sun.com/jsf/html"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:rich="http://richfaces.org/rich"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns="http://www.w3.org/1999/xhtml">

    <div class="row">
        <div class="col-md-12">
            <h:form id="globalform">
                <h1>#{title}</h1>
                #{buildingBlockRepositoryManager.initSelectedBuildingBlockRepository()}
                <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">
                    <ui:param name="styleClass" value="panel-info"/>
                    <ui:define name="panel_title">#{title}</ui:define>

                    <s:decorate id="validatorNameDecoration" template="/layout/form/_edit.xhtml">
                        <ui:param name="id"
                                  value="validatorNameInput"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.ValidatorName_2']}</ui:define>
                        <h:inputText id="validatorNameInput" styleClass="form-control"
                                     required="true"
                                     value="#{buildingBlockRepositoryManager.selectedBuildingBlockRepository.label}">
                        </h:inputText>
                    </s:decorate>

                    <s:decorate id="versionDecoration" template="/layout/form/_edit.xhtml">
                        <ui:param name="id"
                                  value="versionInput"/>
                        <ui:define name="label">#{messages['gazelle.simulator.version']}</ui:define>
                        <h:inputText id="versionInput" styleClass="form-control"
                                     value="#{buildingBlockRepositoryManager.selectedBuildingBlockRepository.version}"
                                     validator="#{buildingBlockRepositoryManager.validateVersion}"
                                     required="true">
                        </h:inputText>
                    </s:decorate>

                    <s:decorate id="versionLabelDecoration" template="/layout/form/_edit.xhtml">
                        <ui:param name="id"
                                  value="versionInput"/>
                        <ui:define name="label">Version label</ui:define>
                        <h:inputText id="versionInput" styleClass="form-control"
                                     value="#{buildingBlockRepositoryManager.selectedBuildingBlockRepository.versionLabel}">
                        </h:inputText>
                    </s:decorate>

                    <s:decorate id="rootClassNameDecoration" template="/layout/form/_edit.xhtml">
                        <ui:param name="id"
                                  value="rootClassNameInput"/>
                        <ui:define name="label">Root Class Name</ui:define>
                        <h:inputText id="rootClassNameInput" styleClass="form-control"
                                     value="#{buildingBlockRepositoryManager.selectedBuildingBlockRepository.rootClassName}">
                        </h:inputText>
                    </s:decorate>

                    <s:decorate id="HL7TEMP_CDACONFFOLDERNAMEDecoration" template="/layout/form/_edit.xhtml">
                        <ui:param name="id"
                                  value="HL7TEMP_CDACONFFOLDERNAMEInput"/>
                        <ui:define name="label">HL7TEMPLATE CDA CONF FOLDER NAME</ui:define>
                        <h:inputText id="HL7TEMP_CDACONFFOLDERNAMEInput" styleClass="form-control"
                                     value="#{buildingBlockRepositoryManager.selectedBuildingBlockRepository.HL7TEMP_CDACONFFOLDERNAME}">
                        </h:inputText>
                    </s:decorate>

                    <s:decorate id="javaVersionDecoration"
                                template="/layout/form/_edit.xhtml">
                        <ui:param name="id" value="javaVersionSelection"/>
                        <ui:define name="label">Java Version</ui:define>
                        <h:selectOneMenu id="javaVersionSelection"
                                         styleClass="form-control gzl-select-text" required="true"
                                         value="#{buildingBlockRepositoryManager.selectedBuildingBlockRepository.javaVersion}">
                            <s:selectItems value="#{buildingBlockRepositoryManager.getAvailableJavaVersions()}"
                                           var="version"
                                           label="#{version.label}" required="true"/>
                        </h:selectOneMenu>
                    </s:decorate>

                    <h:panelGroup rendered="#{buildingBlockRepositoryManager.editMode}">
                        <s:decorate id="statusDecoration"
                                    template="/layout/form/_edit.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.Status']}</ui:define>
                            <ui:param name="id"
                                      value="statusInput"/>
                            <h:selectOneMenu id="statusInput" styleClass="form-control gzl-form-control gzl-select-text"
                                             value="#{buildingBlockRepositoryManager.selectedBuildingBlockRepository.status}">
                                <f:selectItems value="#{buildingBlockRepositoryManager.getAvailableStatus()}"/>
                            </h:selectOneMenu>
                        </s:decorate>
                    </h:panelGroup>

                    <s:decorate template="/layout/form/_edit.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.OnlineBBR']}</ui:define>
                        <ui:param name="id" value="onlineBBRRadio"/>
                        <h:selectOneRadio
                                value="#{buildingBlockRepositoryManager.selectedBuildingBlockRepository.online}">
                            <f:selectItem itemLabel="#{messages['net.ihe.gazelle.True_2']}"
                                          itemValue="true"/>
                            <f:selectItem itemLabel="#{messages['net.ihe.gazelle.False_2']}"
                                          itemValue="false"/>
                            <a4j:ajax event="change" render="onlineSelect"/>
                        </h:selectOneRadio>
                    </s:decorate>
                    <h:panelGroup id="onlineSelect">
                        <h:panelGroup
                                rendered="#{!buildingBlockRepositoryManager.selectedBuildingBlockRepository.online}">
                            <h:panelGroup
                                    rendered="#{buildingBlockRepositoryManager.selectedBuildingBlockRepository.bbrContent != null}">
                                <h:outputText value="#{messages['net.ihe.gazelle.DownloadTheCurrentUploadedFile']} "/>
                                <h:commandLink
                                        title="#{messages['net.ihe.gazelle.cdagen.Download']}"
                                        action="#{buildingBlockRepositoryManager.selectedBuildingBlockRepository.download()}">
                                    <span class="gzl-icon-download"/>
                                </h:commandLink>
                            </h:panelGroup>
                            <rich:fileUpload id="uploadBbr"
                                             fileUploadListener="#{buildingBlockRepositoryManager.uploadBbrListener}"
                                             maxFilesQuantity="1" acceptedTypes="xml" listHeight="90px"
                                             listWidth="width: inherit;" immediateUpload="true">
                            </rich:fileUpload>
                        </h:panelGroup>
                        <h:panelGroup
                                rendered="#{buildingBlockRepositoryManager.selectedBuildingBlockRepository.online}">
                            <s:decorate id="bbrUrlDecoration"
                                        template="/layout/form/_edit.xhtml">
                                <ui:define name="label">#{messages['net.ihe.gazelle.BBRURL']}</ui:define>
                                <ui:param name="id"
                                          value="bbrUrlInput"/>
                                <h:inputText id="bbrUrlInput" styleClass="form-control"
                                             value="#{buildingBlockRepositoryManager.selectedBuildingBlockRepository.url}"
                                             requiredMessage="Please fill in the URL"
                                             required="true">
                                </h:inputText>
                            </s:decorate>
                        </h:panelGroup>
                    </h:panelGroup>

                    <s:div id="panelOF">
                        <h:panelGroup
                                rendered="#{buildingBlockRepositoryManager.selectedBuildingBlockRepository.otherFiles.size != 0}">
                            <h:outputText
                                    value="#{messages['net.ihe.gazelle.DownloadTheCurrentUploadedOtherFilesThatWillBeIn']}"/>
                            <br/>
                            <a4j:repeat var="currentFile"
                                        value="#{buildingBlockRepositoryManager.selectedBuildingBlockRepository.otherFiles}">
                                <h:outputText value="#{currentFile.fileName}"/>
                                <h:commandLink
                                        title="#{messages['net.ihe.gazelle.DownloadOtherFile']}"
                                        action="#{buildingBlockRepositoryManager.selectedBuildingBlockRepository.downloadOtherFile(currentFile.content)}">
                                    <span class="gzl-icon-download"/>
                                </h:commandLink>
                                <a4j:commandLink event="click" title="#{messages['net.ihe.gazelle.DeleteFile']}"
                                                 render="panelOF,gazelle-messages"
                                                 actionListener="#{buildingBlockRepositoryManager.deleteOtherFile(currentFile)}">
                                    <span class="gzl-icon-trash-o"/>
                                </a4j:commandLink>
                                <br/>
                            </a4j:repeat>
                        </h:panelGroup>
                        <h:outputText value="#{messages['net.ihe.gazelle.OtherFilesToAddInTheBBRZIP']} "/>
                        <br/>
                        <rich:fileUpload id="uploadOtherFiles"
                                         fileUploadListener="#{buildingBlockRepositoryManager.uploadOtherFilesListener}"
                                         listHeight="90px"
                                         listWidth="width: inherit;" immediateUpload="true"
                                         render="panelOF">
                        </rich:fileUpload>
                    </s:div>

                    <s:div id="panelXSD">
                        <h:panelGroup
                                rendered="#{buildingBlockRepositoryManager.selectedBuildingBlockRepository.xsdZipFile != null}">
                            <h:outputText
                                    value="#{messages['net.ihe.gazelle.DownloadTheCurrentXSDFileThatWillBeIncludedInThe']}"/>
                            <h:commandLink
                                    title="#{messages['net.ihe.gazelle.DownloadXSDFile']}"
                                    action="#{buildingBlockRepositoryManager.downloadXSDFile(buildingBlockRepositoryManager.selectedBuildingBlockRepository)}">
                                <span class="gzl-icon-download"/>
                            </h:commandLink>
                            <a4j:commandLink event="click" title="#{messages['net.ihe.gazelle.DeleteXSDFile']}"
                                             render="panelXSD,gazelle-messages"
                                             actionListener="#{buildingBlockRepositoryManager.deleteXSDFile(buildingBlockRepositoryManager.selectedBuildingBlockRepository)}">
                                <span class="gzl-icon-trash-o"/>
                            </a4j:commandLink>
                        </h:panelGroup>
                        <br/>
                        <h:outputText value="#{messages['net.ihe.gazelle.XSDZipFileToOverrideTheDefaultCDAOnezipFile']} "/>
                        <rich:fileUpload id="uploadXSDZip" acceptedTypes="zip"
                                         fileUploadListener="#{buildingBlockRepositoryManager.uploadXSDFileListener}"
                                         listHeight="90px"
                                         listWidth="width: inherit;" immediateUpload="true">
                        </rich:fileUpload>
                    </s:div>

                    <s:decorate template="/layout/form/_checkbox.xhtml">
                        <h:selectBooleanCheckbox id="activeCheckbox"
                                                 value="#{buildingBlockRepositoryManager.selectedBuildingBlockRepository.active}">
                        </h:selectBooleanCheckbox>
                        <h:outputText styleClass="help-block"
                                      value="#{messages['net.ihe.gazelle.IsActive']}"/>
                    </s:decorate>
                    <s:decorate template="/layout/form/_checkbox.xhtml">
                        <h:selectBooleanCheckbox id="ignoreTemplateidRequirementsCheckbox"
                                                 value="#{buildingBlockRepositoryManager.selectedBuildingBlockRepository.ignoreTemplateidRequirements}">
                        </h:selectBooleanCheckbox>
                        <h:outputText styleClass="help-block"
                                      value="Ignore templateid requirements"/>
                    </s:decorate>

                    <ui:define name="panel_footer">
                        <h:commandButton id="saveBBR"
                                         value="#{messages['gazelle.simulator.Save']}"
                                         action="#{buildingBlockRepositoryManager.save()}"
                                         styleClass="gzl-btn-green"/>
                        <h:commandLink value="#{messages['net.ihe.gazelle.cdagen.Back']}"
                                       styleClass="gzl-btn"
                                       onclick="window.history.go(-1); return false;"/>

                    </ui:define>
                </ui:decorate>
            </h:form>
        </div>
    </div>
</ui:composition>